<script setup>
import { onMounted, ref, watch } from "vue";
import { Head, Link } from "@inertiajs/vue3";
import axios from "axios";

const drawer = ref(false);
const headers = ref([
    { title: 'Judul', value: 'title' },
    { title: 'ISBN', value: 'isbn' },
    { title: 'Gambar', value: 'image_url', sortable: false },
    { title: 'Kategori', value: 'category' },
    { title: 'Penulis', value: 'author' },
    { title: 'Penerbit', value: 'publisher' },
    { title: 'Tahun', value: 'year' },
    { title: 'Harga', value: 'price' },
    { title: 'Actions', key: 'actions', sortable: false },
])
const snackbar = ref({})
const search = ref("");
const dialog = ref(false)
const dialogDelete = ref(false)
const bookForm = ref({});
const formVal = ref(null)
const items = ref([])

async function submitForm() {
    const { valid } = await formVal.value.validate();
    if (!valid) return true
    axios.post("/books", bookForm.value).then(response => {
        closeForm()
        loadData()
        snackbar.value = { isOpen: true, text: response.data.message, isError: false }
    }).catch(err => {
        snackbar.value = { isOpen: true, text: err.message, isError: false }
    })
}

watch(dialog, (newDialog) => {
    if (!newDialog) {
        resetForm()
    }
})
watch(dialogDelete, (newDialogDelete) => {
    if (!newDialogDelete) {
        bookForm.value = {}
    }
})
function resetForm() {
    formVal.value.reset()
}
function closeForm() {
    dialog.value = false
}
function editItem(item) {
    bookForm.value = { ...item }
    dialog.value = true
}
function deleteItem(item) {
    bookForm.value = { ...item }
    dialogDelete.value = true
}
function confirmDelete() {
    axios.delete(`/books/${bookForm.value.id}`).then(response => {
        snackbar.value = { isOpen: true, text: response.data.message, isError: false }
    }).catch(err => {
        snackbar.value = { isOpen: true, text: "Gagal menghapus buku", isError: true }
    })
    dialogDelete.value = false
}
function isRequired(v) {
    return !!v || "Data tidak boleh kosong"
}
function loadData() {
    axios.get("/books").then(response => {
        items.value = response.data.books
    }).catch(err => {
        snackbar.value = { isOpen: true, text: "Gagal mendapatkan data", isError: true }
    })
}
onMounted(() => {
    loadData()
})

</script>

<template>
    <v-app id="inspire" theme="dark">

        <Head title="Workshop" />
        <v-navigation-drawer v-model="drawer">
            <v-list>
                <v-list-item prepend-icon="mdi-view-dashboard" title="Dashboard" :to="'dashboard'"
                    :active="true"></v-list-item>
            </v-list>

            <template v-slot:append>
                <div class="pa-2">
                    <Link href="/logout" method="post" as="div">
                    <v-btn block color="red" variant="tonal"> Logout </v-btn>
                    </Link>
                </div>
            </template>
        </v-navigation-drawer>

        <v-app-bar>
            <v-app-bar-nav-icon @click="drawer = !drawer"></v-app-bar-nav-icon>

            <v-app-bar-title>Workshop UNUSIDA</v-app-bar-title>
        </v-app-bar>

        <v-main>
            <v-card>
                <v-card-title class="d-flex align-center pe-2">
                    <v-icon icon="mdi-bookshelf"></v-icon> &nbsp;
                    Katalog Buku
                    <v-spacer></v-spacer>
                    <v-text-field append-inner-icon="mdi-magnify" density="compact" label="Cari Buku" variant="outlined"
                        hide-details single-line v-model="search"></v-text-field>
                    <v-btn prepend-icon="mdi-plus" class="text-none text-subtitle-1 ml-2" color="green"
                        @click="dialog = true" variant="outlined">
                        Tambah Buku
                    </v-btn>
                </v-card-title>
                <v-divider></v-divider>
                <v-data-table v-model:search="search" :items="items" :headers="headers">
                    <template v-slot:header.price>
                        <div class="text-end">Harga</div>
                    </template>
                    <template v-slot:item.image_url="{ item }">
                        <v-card class="my-2" elevation="2" rounded>
                            <v-img :src="item.image_url" height="64" cover></v-img>
                        </v-card>
                    </template>
                    <template v-slot:item.price="{ item }">
                        <div class="text-end">
                            {{ item.price }}
                        </div>
                    </template>
                    <template v-slot:item.actions="{ item }">
                        <v-icon class="me-2" size="small" @click="editItem(item)">
                            mdi-pencil
                        </v-icon>
                        <v-icon size="small" @click="deleteItem(item)">
                            mdi-delete
                        </v-icon>
                    </template>
                </v-data-table>
            </v-card>
            <v-dialog v-model="dialog" max-width="600">
                <v-form ref="formVal">
                    <v-card prepend-icon="mdi-account" title="Form Buku">
                        <v-card-text>
                            <v-row dense>
                                <v-col cols="12">
                                    <v-text-field label="ISBN*" v-model="bookForm.isbn"
                                        :rules="[isRequired]"></v-text-field>
                                </v-col>
                                <v-col cols="12">
                                    <v-text-field label="Judul Buku*" v-model="bookForm.title"
                                        :rules="[isRequired]"></v-text-field>
                                </v-col>
                                <v-col cols="12">
                                    <v-autocomplete
                                        :items="['Antologi', 'Biografi', 'Cergam', 'Ensiklopedi', 'Karya Ilmiah', 'Komik', 'Majalah', 'Novel', 'Tafsir']"
                                        label="Kategori" v-model="bookForm.category" auto-select-first></v-autocomplete>
                                </v-col>
                                <v-col cols="12">
                                    <v-text-field label="Link Sampul Buku" v-model="bookForm.image_url"></v-text-field>
                                </v-col>
                                <v-col cols="12">
                                    <v-text-field label="Penulis*" v-model="bookForm.author"
                                        :rules="[isRequired]"></v-text-field>
                                </v-col>
                                <v-col cols="12">
                                    <v-text-field label="Penerbit" v-model="bookForm.publisher"></v-text-field>
                                </v-col>
                                <v-col cols="12">
                                    <v-text-field label="Tahun Terbit" v-model="bookForm.year"
                                        type="number"></v-text-field>
                                </v-col>
                                <v-col cols="12">
                                    <v-text-field label="Harga*" v-model="bookForm.price" :rules="[isRequired]"
                                        type="number"></v-text-field>
                                </v-col>

                            </v-row>

                            <small class="text-caption text-medium-emphasis">*indicates required field</small>
                        </v-card-text>

                        <v-divider></v-divider>

                        <v-card-actions>
                            <v-spacer></v-spacer>

                            <v-btn color="red" text="Tutup" variant="plain" @click="closeForm"></v-btn>

                            <v-btn color="green" text="Simpan" variant="tonal" @click="submitForm"></v-btn>
                        </v-card-actions>
                    </v-card>
                </v-form>
            </v-dialog>
            <v-snackbar v-model="snackbar.isOpen" multi-line>
                {{ snackbar.text }}

                <template v-slot:actions>
                    <v-btn :color="snackbar.isError ? 'red' : 'green'" variant="text" timeout="2000"
                        @click="snackbar.isOpen = false">
                        Close
                    </v-btn>
                </template>
            </v-snackbar>
            <v-dialog v-model="dialogDelete" max-width="400" persistent>
                <v-card prepend-icon="mdi-book-remove-outline" text="Apakah anda setuju untuk menghapus buku ini??"
                    title="Hapus Buku">
                    <template v-slot:actions>
                        <v-spacer></v-spacer>

                        <v-btn @click="dialogDelete = false" color="green">
                            Batal
                        </v-btn>

                        <v-btn @click="confirmDelete" color="red">
                            Delete
                        </v-btn>
                    </template>
                </v-card>
            </v-dialog>
        </v-main>
    </v-app>
</template>